### Botping: Ping bots on the botnet to check lagtime.
### Usage: .bping [bot]
### 6/23/97 Version 1.0: Run on a couple bots.. appears to run fine.
### 6/24/97 Version 1.1: Only responds to a ping every 20 seconds to 
###   reduce flooding.
### 1/18/02 Version 1.2: Use milliseconds if available
###   Also fixes a TCL vulnerability (BarkerJr)


proc ping_send {hand idx text} {
  global pingidx tcl_version
  set pingidx $idx
  set bots [string tolower [bots]]
  set pingbot [string tolower [lindex $text 0]]
  if {$tcl_version >= 8.3} {
    set time [clock clicks -milliseconds]
  } else {
    set time [unixtime]
  }
  if {$pingbot != ""} {
    if {[lsearch $bots $pingbot] != "-1"} {
      putbot $pingbot "BOTPING $time"
      putdcc $idx "Pinging $pingbot."
    } else {
      putdcc $idx "That bot isn't on the botnet."
      return 0
    }
  } else {
    putallbots "BOTPING $time"
    putdcc $idx "Pinging the entire botnet."
  }
  return 1
}

proc ping_echo {bot command text} {
  global replied_ping
  if {$command == "BOTPING" && ![info exists replied_ping]} {
    set replied_ping yes
    utimer 20 {unset replied_ping}
    putbot $bot "BOTPING_RPLY $text"
    putlog "Pinged by $bot"
  }
}

proc ping_reply {bot command text} {
  global pingidx tcl_version
  if {$command == "BOTPING_RPLY"} {
    if {$tcl_version >= 8.3} {
      set replytime [expr [expr [clock clicks -milliseconds] - [split $text]] / 1000.0]
    } else {
      set replytime [expr [unixtime] - [split $text]]
    }
    putdcc $pingidx "Ping reply from $bot\: $replytime secs"
  }
}

bind dcc m bping ping_send
bind bot - BOTPING ping_echo
bind bot - BOTPING_RPLY ping_reply
